diff -urN Original_4.4.4_r1/packages/apps/Settings/src/com/android/settings/collaboroid/CollaboRoidSettings.java AndroidSource/packages/apps/Settings/src/com/android/settings/collaboroid/CollaboRoidSettings.java
--- Original_4.4.4_r1/packages/apps/Settings/src/com/android/settings/collaboroid/CollaboRoidSettings.java	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/packages/apps/Settings/src/com/android/settings/collaboroid/CollaboRoidSettings.java	2016-06-22 20:46:06.000000000 +0900
@@ -0,0 +1,527 @@
+/*
+ * Copyright (C) 2010 The Android Open Source Project
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+package com.android.settings.collaboroid;
+
+import static android.os.UserManager.DISALLOW_CONFIG_WIFI;
+
+import java.util.ArrayList;
+import java.util.Collection;
+import java.util.List;
+
+import android.app.ActionBar;
+import android.app.Activity;
+import android.app.Dialog;
+import android.content.BroadcastReceiver;
+import android.content.Context;
+import android.content.DialogInterface;
+import android.content.Intent;
+import android.content.IntentFilter;
+import android.content.res.Resources;
+import android.content.res.TypedArray;
+import android.os.Bundle;
+import android.preference.CheckBoxPreference;
+import android.preference.Preference;
+import android.preference.PreferenceActivity;
+import android.preference.PreferenceScreen;
+import android.provider.Settings;
+import android.service.collaboroid.CollaboRoidManager;
+import android.service.devicemanager.Device;
+import android.service.devicemanager.DeviceManager;
+import android.service.remote.RemoteServiceManager;
+import android.util.AttributeSet;
+import android.util.Log;
+import android.view.ContextMenu;
+import android.view.ContextMenu.ContextMenuInfo;
+import android.view.Gravity;
+import android.view.LayoutInflater;
+import android.view.Menu;
+import android.view.MenuInflater;
+import android.view.MenuItem;
+import android.view.View;
+import android.view.ViewGroup;
+import android.widget.CompoundButton;
+import android.widget.CompoundButton.OnCheckedChangeListener;
+import android.widget.RelativeLayout;
+import android.widget.Switch;
+import android.widget.TextView;
+
+import com.android.settings.R;
+import com.android.settings.RestrictedSettingsFragment;
+
+
+/**
+ * Two types of UI are provided here.
+ *
+ * The first is for "usual Settings", appearing as any other Setup fragment.
+ *
+ * The second is for Setup Wizard, with a simplified interface that hides the action bar
+ * and menus.
+ */
+public class CollaboRoidSettings extends RestrictedSettingsFragment
+        implements DialogInterface.OnClickListener  {
+   
+	private static final String TAG = "CollaboRoidSettings";
+	
+	private static final int REMOTE_DEVICE_DIALOG_ID = 1;
+	/*private static final int WPS_PBC_DIALOG_ID = 2;
+	private static final int WPS_PIN_DIALOG_ID = 3;
+	private static final int WIFI_SKIPPED_DIALOG_ID = 4;
+	private static final int WIFI_AND_MOBILE_SKIPPED_DIALOG_ID = 5;*/
+	
+	private static final int MENU_REFRESH_ID = 1;
+	private static final int MENU_START_ID = 2;
+	
+	private final IntentFilter mFilter;
+	private final BroadcastReceiver mReceiver;
+	
+	private TextView mEmptyView;
+	
+	private CollaboRoidEnabler mCollaboRoidEnabler;
+	
+	private RemoteDevice mSelectedRemoteDevice;
+	private CollaboRoidDialog mDialog;
+	
+	// Save the dialog details
+	//private boolean mDlgEdit;
+	private RemoteDevice mDlgRemoteDevice;
+	private Bundle mRemoteDeviceSavedState;
+	
+	private DeviceManager mDeviceManager;
+	private RemoteServiceManager mRemoteManager;
+	
+	private Switch actionBarSwitch;
+	
+	private final ArrayList<RemoteDevice> selectedRemoteDevices = new ArrayList<RemoteDevice>();
+	
+	
+	
+    public CollaboRoidSettings() {
+    	 super(DISALLOW_CONFIG_WIFI);
+    	 mFilter = new IntentFilter();
+    	 mFilter.addAction(CollaboRoidManager.COLLABOROID_STATE_CHANGED_ACTION);
+    	 
+    	 mReceiver = new BroadcastReceiver() {
+			@Override
+			public void onReceive(Context context, Intent intent) {
+				// TODO Auto-generated method stub
+				if(intent.getIntExtra(CollaboRoidManager.EXTRA_COLLABOROID_STATE, CollaboRoidManager.COLLABOROID_STATE_UNKNOWN)
+						== CollaboRoidManager.COLLABOROID_STATE_DISABLED)
+					setOffMessage();
+			}
+		};
+    }
+
+    @Override
+    public void onCreate(Bundle icicle) {
+        // Set this flag early, as it's needed by getHelpResource(), which is called by super
+     
+    	Log.d(TAG, "onCreate");
+        super.onCreate(icicle);
+    }
+
+    @Override
+    public View onCreateView(final LayoutInflater inflater, ViewGroup container,
+            Bundle savedInstanceState) {
+    	
+    	Log.d(TAG, "onCreateView");
+    	
+    	return super.onCreateView(inflater, container, savedInstanceState);
+        
+    }
+
+    @Override
+    public void onActivityCreated(Bundle savedInstanceState) {
+        super.onActivityCreated(savedInstanceState);
+
+        final Activity activity = getActivity();
+        mDeviceManager = (DeviceManager) getSystemService(Context.DEVICE_MANAGEMENT_SERVICE);
+        mRemoteManager = (RemoteServiceManager) getSystemService(Context.REMOTE_SERVICE);
+        
+        //final Intent intent = activity.getIntent();
+        addPreferencesFromResource(R.xml.collaboroid_settings);
+        
+        actionBarSwitch = new Switch(activity);
+        
+        if (activity instanceof PreferenceActivity) {
+            PreferenceActivity preferenceActivity = (PreferenceActivity) activity;
+            if (preferenceActivity.onIsHidingHeaders() || !preferenceActivity.onIsMultiPane()) {
+                final int padding = activity.getResources().getDimensionPixelSize(
+                        R.dimen.action_bar_switch_padding);
+                actionBarSwitch.setPaddingRelative(0, 0, padding, 0);
+                activity.getActionBar().setDisplayOptions(ActionBar.DISPLAY_SHOW_CUSTOM,
+                        ActionBar.DISPLAY_SHOW_CUSTOM);
+                activity.getActionBar().setCustomView(actionBarSwitch, new ActionBar.LayoutParams(
+                        ActionBar.LayoutParams.WRAP_CONTENT,
+                        ActionBar.LayoutParams.WRAP_CONTENT,
+                        Gravity.CENTER_VERTICAL | Gravity.END));
+            }
+        }
+        
+        mCollaboRoidEnabler = new CollaboRoidEnabler(activity, actionBarSwitch);
+        
+        mEmptyView = (TextView) getView().findViewById(android.R.id.empty);
+        getListView().setEmptyView(mEmptyView);
+        
+        registerForContextMenu(getListView());
+        setHasOptionsMenu(true);
+    }
+
+    @Override
+    public void onResume() {
+        super.onResume();
+        if(mCollaboRoidEnabler != null)
+        {
+        	mCollaboRoidEnabler.resume();
+        }
+        getActivity().registerReceiver(mReceiver, mFilter);
+        updateRemoteDevices();
+    }
+
+    @Override
+    public void onPause() {
+    	super.onPause();
+    	if(mCollaboRoidEnabler != null)
+        {
+        	mCollaboRoidEnabler.pause();
+        }
+    	getActivity().unregisterReceiver(mReceiver);
+    }
+
+    @Override
+    public void onCreateOptionsMenu(Menu menu, MenuInflater inflater) {
+    	TypedArray ta = getActivity().getTheme().obtainStyledAttributes(
+                new int[] {R.attr.ic_menu_add, R.attr.ic_wps});
+    	
+		menu.add(Menu.NONE, MENU_REFRESH_ID, 0, R.string.collaboroid_menu_refresh)
+				//.setIcon(ta.getDrawable(1))
+				.setEnabled(true)
+				.setShowAsAction(MenuItem.SHOW_AS_ACTION_IF_ROOM);
+		menu.add(Menu.NONE, MENU_START_ID, 0, R.string.collaboroid_menu_start)
+				//.setIcon(ta.getDrawable(0))
+				.setEnabled(true)
+				.setShowAsAction(MenuItem.SHOW_AS_ACTION_ALWAYS);
+		/*menu.add(Menu.NONE, 2, 0, R.string.wifi_menu_scan)
+				// .setIcon(R.drawable.ic_menu_scan_network)
+				.setEnabled(true)
+				.setShowAsAction(MenuItem.SHOW_AS_ACTION_NEVER);*/
+		ta.recycle();
+        
+        super.onCreateOptionsMenu(menu, inflater);
+    }
+
+    @Override
+    public void onSaveInstanceState(Bundle outState) {
+        super.onSaveInstanceState(outState);
+
+      
+    }
+
+    @Override
+    public boolean onOptionsItemSelected(MenuItem item) {
+        // If the user is not allowed to configure wifi, do not handle menu selections.
+    //    if (isRestrictedAndNotPinProtected()) return false;
+
+    	Log.d(TAG, "onOptionItemSelected: " + item.getItemId());
+    	if(item.getItemId() == MENU_REFRESH_ID)
+    	{
+    		updateRemoteDevices();
+    		mRemoteManager.testOperation();
+    	}
+    	else if(item.getItemId() == MENU_START_ID)
+    	{
+    		//mDeviceManager.constructCluster(remoteDevicesToDevices(selectedRemoteDevices));
+    		mDeviceManager.askResources(remoteDevicesToDevices(selectedRemoteDevices));
+    		mRemoteManager.startServer();
+    	}
+        
+        return super.onOptionsItemSelected(item);
+    }
+    
+    public List<Device> remoteDevicesToDevices(List<RemoteDevice> remoteDevices)
+    {
+    	List<Device> devices = new ArrayList<Device>();
+    	
+    	for(RemoteDevice rd : remoteDevices)
+    		devices.add(rd.getDevice());
+    	
+    	return devices;
+    }
+
+    @Override
+    public void onCreateContextMenu(ContextMenu menu, View view, ContextMenuInfo info) {
+        
+    }
+
+    @Override
+    public boolean onContextItemSelected(MenuItem item) {
+    	Log.d(TAG, "onContextItemSelected: " + item.getItemId());
+    	
+        return super.onContextItemSelected(item);
+    }
+
+    @Override
+    public boolean onPreferenceTreeClick(PreferenceScreen screen, Preference preference) {
+    	
+    	//here!!
+    	if (preference instanceof RemoteDevice)
+		{
+    		if(((CheckBoxPreference)preference).isChecked())
+    		{
+    			selectedRemoteDevices.add((RemoteDevice)preference);
+    			mSelectedRemoteDevice = (RemoteDevice) preference;
+    			showDialog(mSelectedRemoteDevice);
+    		}
+    		else
+    			selectedRemoteDevices.remove(preference);
+		}
+    	else
+			return super.onPreferenceTreeClick(screen, preference);
+	
+		return true;
+    }
+    
+    private void showDialog(RemoteDevice remoteDevice)
+	{
+		if (mDialog != null)
+		{
+			//removeDialog(REMOTE_DEVICE_DIALOG_ID);
+			mDialog = null;
+		}
+
+		// Save the access point and edit mode
+		mDlgRemoteDevice = remoteDevice;
+		//mDlgEdit = edit;
+
+		showDialog(REMOTE_DEVICE_DIALOG_ID);
+	}
+
+   
+    @Override
+    public Dialog onCreateDialog(int dialogId) {
+    	
+        
+    	switch (dialogId)
+		{
+		case REMOTE_DEVICE_DIALOG_ID:
+			RemoteDevice rd = mDlgRemoteDevice; // For manual launch
+			Log.d(TAG, "onCreateDialog: " + rd.name);
+			
+			// null exception !!!!!!!!!!!!!!!!!!!!!!!!
+			
+			/*if (rd == null)
+			{ // For re-launch from saved state
+				if (mAccessPointSavedState != null)
+				{
+					ap = new AccessPoint(getActivity(), mAccessPointSavedState);
+					// For repeated orientation changes
+					mDlgRemoteDevice = ap;
+					// Reset the saved access point data
+					mAccessPointSavedState = null;
+				}
+			}*/
+			// If it's still null, fine, it's for Add Network
+			//mSelectedAccessPoint = ap;
+			
+			mDialog = new CollaboRoidDialog(getActivity(), this, rd);
+			mDialog.setSubmitButton(getActivity().getString(R.string.collaboroid_submit));
+			mDialog.setCancelButton(getActivity().getString(R.string.collaboroid_cancel));
+			mDialog.setTitle(rd.name);
+			return mDialog;
+		}
+    	
+        return super.onCreateDialog(dialogId);
+    }
+
+
+    @Override
+    public void onClick(DialogInterface dialogInterface, int button) {
+        /*if (button == WifiDialog.BUTTON_FORGET && mSelectedAccessPoint != null) {
+            forget();
+        } else if (button == WifiDialog.BUTTON_SUBMIT) {
+            if (mDialog != null) {
+                submit(mDialog.getController());
+            }
+        }*/
+    	
+    	Log.d(TAG, "onClick: " + button);
+    	if (button == CollaboRoidDialog.BUTTON_SUBMIT)
+		{
+			if (mDialog != null)
+			{
+				submit(mDialog);
+			}
+		}
+    }
+
+    void submit(CollaboRoidDialog dialog)
+    {
+    	mSelectedRemoteDevice.setAllowedResources(dialog.getAllowedResources());
+    	mSelectedRemoteDevice.setAskedResources(dialog.getAskedResources());
+    	
+    	/*int[] resources = dialog.getAllowedResources();
+    	for(int i=0; i<7; i++)
+    		Log.d(TAG, "allow: " + resources[i]);
+    	
+    	int[] resources2 = dialog.getAskedResources();
+    	for(int i=0; i<7; i++)
+    		Log.d(TAG, "ask: " + resources2[i]);
+    	
+    	Log.d(TAG, "TEST:" + resources2.toString());*/
+    	
+    	
+    }
+    
+    @Override
+    protected int getHelpResource() {
+        
+        return R.string.help_url_wifi;
+    }
+    
+    private void updateRemoteDevices()
+	{
+		// Safeguard from some delayed event handling
+		if (getActivity() == null)
+			return;
+		
+		final Collection<RemoteDevice> remoteDevices = findRemoteDevices();
+		getPreferenceScreen().removeAll();
+		
+		/*ArrayList<String> resources = new ArrayList<String>();
+    	resources.add("Touch");
+    	resources.add("Key");
+    	resources.add("Sensor");
+    	resources.add("Location");
+    	resources.add("Audio");
+    	resources.add("Video");
+		
+		RemoteDevice rd = new RemoteDevice(getActivity(), "JAKE", "21%", resources);
+		getPreferenceScreen().addPreference(rd);
+		
+		rd = new RemoteDevice(getActivity(), "SAM", "45%", resources);
+		getPreferenceScreen().addPreference(rd);*/
+		
+		/*if (remoteDevices.size() == 0)
+		{
+			addMessagePreference(R.string.collaboroid_empty_list);
+		}
+		else*/
+		
+		if(mDeviceManager.getNumofConfiguredDevices() > 0)
+		{
+			for (RemoteDevice remoteDevice : remoteDevices)
+			{
+				Device rd = mDeviceManager.getDevice(remoteDevice.name); 
+				if(rd != null)
+				{
+					remoteDevice.setAskedResources(rd.askedResources);
+					remoteDevice.setAllowedResources(rd.allowedResources);
+					remoteDevice.setChecked(true);
+				}
+				
+				getPreferenceScreen().addPreference(remoteDevice);
+			}
+		}
+		else
+			for (RemoteDevice remoteDevice : remoteDevices)
+			{
+				getPreferenceScreen().addPreference(remoteDevice);
+			}
+	}
+    
+    private void setOffMessage()
+    {
+    	if (mEmptyView != null) {
+			mEmptyView.setText(R.string.collaboroid_empty_list);
+		}
+		getPreferenceScreen().removeAll();
+	}
+	
+    
+    private void addMessagePreference(int messageId)
+	{
+		if (mEmptyView != null)
+			mEmptyView.setText(messageId);
+		getPreferenceScreen().removeAll();
+	}
+    
+    List<RemoteDevice> findRemoteDevices()
+    {
+    	List<Device> devices = mDeviceManager.getDeviceList(1);
+    	ArrayList<RemoteDevice> remoteDevices = new ArrayList<RemoteDevice>();
+    	
+    	// need to be modified
+    	ArrayList<Integer> resources = new ArrayList<Integer>();
+    	
+    	resources.add(Device.RESOURCE_TYPE_TOUCH);
+    	resources.add(Device.RESOURCE_TYPE_KEY);
+    	resources.add(Device.RESOURCE_TYPE_SENSOR);
+    	resources.add(Device.RESOURCE_TYPE_LOCATION);
+    	resources.add(Device.RESOURCE_TYPE_VIDEO);
+    	resources.add(Device.RESOURCE_TYPE_AUDIO);
+    	resources.add(Device.RESOURCE_TYPE_VIBRATOR);
+    	
+    	
+    	for(Device device : devices)
+    	{
+    		RemoteDevice remoteDevice = new RemoteDevice(getActivity(), device, resources);
+    		remoteDevices.add(remoteDevice);
+    		Log.d(TAG, device.toString());
+    	}
+    	
+    	return remoteDevices;
+    }
+
+    /**
+     * Used as the outer frame of all setup wizard pages that need to adjust their margins based
+     * on the total size of the available display. (e.g. side margins set to 10% of total width.)
+     */
+    public static class ProportionalOuterFrame extends RelativeLayout {
+        public ProportionalOuterFrame(Context context) {
+            super(context);
+        }
+        public ProportionalOuterFrame(Context context, AttributeSet attrs) {
+            super(context, attrs);
+        }
+        public ProportionalOuterFrame(Context context, AttributeSet attrs, int defStyle) {
+            super(context, attrs, defStyle);
+        }
+
+        /**
+         * Set our margins and title area height proportionally to the available display size
+         */
+        @Override
+        protected void onMeasure(int widthMeasureSpec, int heightMeasureSpec) {
+            int parentWidth = MeasureSpec.getSize(widthMeasureSpec);
+            int parentHeight = MeasureSpec.getSize(heightMeasureSpec);
+            final Resources resources = getContext().getResources();
+            float titleHeight = resources.getFraction(R.dimen.setup_title_height, 1, 1);
+            float sideMargin = resources.getFraction(R.dimen.setup_border_width, 1, 1);
+            int bottom = resources.getDimensionPixelSize(R.dimen.setup_margin_bottom);
+            setPaddingRelative(
+                    (int) (parentWidth * sideMargin),
+                    0,
+                    (int) (parentWidth * sideMargin),
+                    bottom);
+            View title = findViewById(R.id.title_area);
+            if (title != null) {
+                title.setMinimumHeight((int) (parentHeight * titleHeight));
+            }
+            super.onMeasure(widthMeasureSpec, heightMeasureSpec);
+        }
+    }
+
+}
diff -urN Original_4.4.4_r1/packages/apps/Settings/src/com/android/settings/Settings.java AndroidSource/packages/apps/Settings/src/com/android/settings/Settings.java
--- Original_4.4.4_r1/packages/apps/Settings/src/com/android/settings/Settings.java	2016-01-29 15:12:43.179488000 +0900
+++ AndroidSource/packages/apps/Settings/src/com/android/settings/Settings.java	2016-01-13 12:21:58.000000000 +0900
@@ -71,6 +71,8 @@
 import com.android.settings.applications.ProcessStatsUi;
 import com.android.settings.bluetooth.BluetoothEnabler;
 import com.android.settings.bluetooth.BluetoothSettings;
+import com.android.settings.collaboroid.CollaboRoidEnabler;
+import com.android.settings.collaboroid.CollaboRoidSettings;
 import com.android.settings.deviceinfo.Memory;
 import com.android.settings.deviceinfo.UsbSettings;
 import com.android.settings.fuelgauge.PowerUsageSummary;
@@ -136,6 +138,7 @@
     private int[] SETTINGS_FOR_RESTRICTED = {
             R.id.wireless_section,
             R.id.wifi_settings,
+            R.id.collaboroid_settings,
             R.id.bluetooth_settings,
             R.id.data_usage_settings,
             R.id.wireless_settings,
@@ -309,6 +312,7 @@
     private static final String[] ENTRY_FRAGMENTS = {
         WirelessSettings.class.getName(),
         WifiSettings.class.getName(),
+        CollaboRoidSettings.class.getName(),
         AdvancedWifiSettings.class.getName(),
         BluetoothSettings.class.getName(),
         TetherSettings.class.getName(),
@@ -505,6 +509,7 @@
         // uiOptions for fragments also defined as activities in manifest.
         if (WifiSettings.class.getName().equals(fragmentName) ||
                 WifiP2pSettings.class.getName().equals(fragmentName) ||
+                CollaboRoidSettings.class.getName().equals(fragmentName) ||
                 BluetoothSettings.class.getName().equals(fragmentName) ||
                 DreamSettings.class.getName().equals(fragmentName) ||
                 LocationSettings.class.getName().equals(fragmentName) ||
@@ -779,6 +784,7 @@
         private static final int HEADER_TYPE_COUNT = HEADER_TYPE_BUTTON + 1;
 
         private final WifiEnabler mWifiEnabler;
+        private final CollaboRoidEnabler mCollaboRoidEnabler;
         private final BluetoothEnabler mBluetoothEnabler;
         private AuthenticatorHelper mAuthHelper;
         private DevicePolicyManager mDevicePolicyManager;
@@ -797,7 +803,7 @@
         static int getHeaderType(Header header) {
             if (header.fragment == null && header.intent == null) {
                 return HEADER_TYPE_CATEGORY;
-            } else if (header.id == R.id.wifi_settings || header.id == R.id.bluetooth_settings) {
+            } else if (header.id == R.id.wifi_settings || header.id == R.id.collaboroid_settings || header.id == R.id.bluetooth_settings) {
                 return HEADER_TYPE_SWITCH;
             } else if (header.id == R.id.security_settings) {
                 return HEADER_TYPE_BUTTON;
@@ -842,6 +848,7 @@
             // Temp Switches provided as placeholder until the adapter replaces these with actual
             // Switches inflated from their layouts. Must be done before adapter is set in super
             mWifiEnabler = new WifiEnabler(context, new Switch(context));
+            mCollaboRoidEnabler = new CollaboRoidEnabler(context, new Switch(context));
             mBluetoothEnabler = new BluetoothEnabler(context, new Switch(context));
             mDevicePolicyManager = dpm;
         }
@@ -912,7 +919,12 @@
                     // Would need a different treatment if the main menu had more switches
                     if (header.id == R.id.wifi_settings) {
                         mWifiEnabler.setSwitch(holder.switch_);
-                    } else {
+                    }
+                    else if(header.id == R.id.collaboroid_settings)
+                    {
+                    	mCollaboRoidEnabler.setSwitch(holder.switch_);
+                    }
+                    else {
                         mBluetoothEnabler.setSwitch(holder.switch_);
                     }
                     updateCommonHeaderView(header, holder);
@@ -986,11 +998,13 @@
 
         public void resume() {
             mWifiEnabler.resume();
+            mCollaboRoidEnabler.resume();
             mBluetoothEnabler.resume();
         }
 
         public void pause() {
             mWifiEnabler.pause();
+            mCollaboRoidEnabler.pause();
             mBluetoothEnabler.pause();
         }
     }
